CREATE SEQUENCE BO_S_OPERATION START WITH 1 INCREMENT BY 1;

CREATE TABLE BO_T_OPERATION (
  OPE_N_ID                    NUMBER(12)         CONSTRAINT BO_NN_OPERATION_ID NOT NULL,
  OPE_C_SHORT_LABEL           VARCHAR2(50 CHAR)  CONSTRAINT BO_NN_OPERATION_SLABEL NOT NULL,
  OPE_C_LONG_LABEL            VARCHAR2(200 CHAR) CONSTRAINT BO_NN_OPERATION_LLABEL NOT NULL,
  OPE_D_DATE                  TIMESTAMP          CONSTRAINT BO_NN_OPERATION_DATE NOT NULL,
  OPE_N_GRACE_PERIOD          NUMBER(12),
  OPE_C_LOGIN                 VARCHAR2(50 CHAR)  CONSTRAINT BO_NN_OPERATION_LOGIN NOT NULL,
  OPE_D_SAVE                  TIMESTAMP          CONSTRAINT BO_NN_OPERATION_SAVE NOT NULL,
  OPE_D_LAST_CONFIG_DATE      TIMESTAMP          CONSTRAINT BO_NN_OPERATION_LAST_CFG_DATE NOT NULL,
  OPE_C_REG_HASH              VARCHAR2(128 CHAR),
  OPE_C_SIMULATION_NAME       VARCHAR2(40 CHAR),
  OPE_C_DEPLOYMENT_TARGET     VARCHAR2(20 CHAR)  CONSTRAINT BO_NN_OPERATION_DEPLOY_TARGET NOT NULL,
  OPE_D_LAST_VOT_MAT_UPD_DATE TIMESTAMP          CONSTRAINT BO_NN_OPERATION_LAST_VM_DATE NOT NULL,
  OPE_D_LAST_VOT_PER_UPD_DATE TIMESTAMP          CONSTRAINT BO_NN_OPERATION_LAST_VP_DATE NOT NULL,
  OPE_C_VOTING_CARD_TITLE     VARCHAR2(40 CHAR),
  OPE_C_PRINTER_TEMPLATE      VARCHAR2(200 CHAR),
  OPE_C_MANAGEMENT_ENTITY      VARCHAR2(200 CHAR) CONSTRAINT BO_NN_OPERATION_MGT_ENTITY NOT NULL,
  OPE_N_IN_MODIFICATION       NUMBER(1, 0)       CONSTRAINT BO_NN_IN_MODIFICATION NOT NULL,
  OPE_C_CANTON                VARCHAR2(2 CHAR)   CONSTRAINT BO_NN_OPERATION_CANTON NOT NULL,
  OPE_C_WORKFLOW_STEP         VARCHAR2(40 CHAR)  CONSTRAINT BO_NN_WORKFLOW_STEP NOT NULL,
  CONSTRAINT BO_K_OPERATION PRIMARY KEY (OPE_N_ID)
);

COMMENT ON TABLE BO_T_OPERATION IS 'Electoral operations';
COMMENT ON COLUMN BO_T_OPERATION.OPE_N_ID IS 'Unique ID';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_SHORT_LABEL IS 'Operation''s short label';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_LONG_LABEL IS 'Operation''s long label';
COMMENT ON COLUMN BO_T_OPERATION.OPE_D_DATE IS 'Operation''s date';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_LOGIN IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_OPERATION.OPE_D_SAVE IS 'Date and time of the last modification in the table content';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_REG_HASH IS 'hash of register files';
COMMENT ON COLUMN BO_T_OPERATION.OPE_D_LAST_CONFIG_DATE IS 'Date and time of the last modification of configuration';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_SIMULATION_NAME IS 'Name of the simulation if the deploymentTarget is set to simulation';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_DEPLOYMENT_TARGET IS 'Current deployment target for the operation (one of NOT_DEFINED, SIMULATION, PRODUCTION)';
COMMENT ON COLUMN BO_T_OPERATION.OPE_D_LAST_VOT_MAT_UPD_DATE IS 'Date and time of the last modification of voting material';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_VOTING_CARD_TITLE IS 'Title printed on voting card';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_PRINTER_TEMPLATE IS 'Selected printer template';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_MANAGEMENT_ENTITY IS 'Management entity responsible for the operation';
COMMENT ON COLUMN BO_T_OPERATION.OPE_N_IN_MODIFICATION IS 'Operation is currently on pending modification (ie not sent to PACT)';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_CANTON IS 'Canton responsible for the operation';
COMMENT ON COLUMN BO_T_OPERATION.OPE_C_WORKFLOW_STEP IS 'Coarse-grained operation''s workflow status';
CREATE SEQUENCE BO_S_MILESTONE START WITH 1 INCREMENT BY 1;

CREATE TABLE BO_T_MILESTONE (
  MIL_N_ID     NUMBER(12)        CONSTRAINT BO_NN_MILESTONE_ID NOT NULL,
  MIL_C_TYPE   VARCHAR2(50)      CONSTRAINT BO_NN_MILESTONE_TYPE NOT NULL,
  MIL_D_DATE   TIMESTAMP,
  MIL_OPE_N_ID NUMBER(12)        CONSTRAINT BO_NN_MIL_OPE NOT NULL,
  CONSTRAINT BO_F_MIL_OPE FOREIGN KEY (MIL_OPE_N_ID) REFERENCES BO_T_OPERATION (OPE_N_ID),
  MIL_C_LOGIN  VARCHAR2(50 CHAR) CONSTRAINT BO_NN_MILESTONE_LOGIN NOT NULL,
  MIL_D_SAVE   TIMESTAMP         CONSTRAINT BO_NN_MILESTONE_SAVE NOT NULL,
  CONSTRAINT BO_K_MILESTONE PRIMARY KEY (MIL_N_ID)
);

COMMENT ON TABLE BO_T_MILESTONE IS 'Operation''s milestones';
COMMENT ON COLUMN BO_T_MILESTONE.MIL_N_ID IS 'Unique ID';
COMMENT ON COLUMN BO_T_MILESTONE.MIL_C_TYPE IS 'Milestone type';
COMMENT ON COLUMN BO_T_MILESTONE.MIL_D_DATE IS 'Milestone''s date';
COMMENT ON COLUMN BO_T_MILESTONE.MIL_OPE_N_ID IS 'Operation''s ID';
COMMENT ON COLUMN BO_T_MILESTONE.MIL_C_LOGIN IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_MILESTONE.MIL_D_SAVE IS 'Date and time of the last modification in the table content';

CREATE SEQUENCE BO_S_FILES START WITH 1 INCREMENT BY 1;

CREATE TABLE BO_T_FILES (
  FIL_N_ID                NUMBER(12)         CONSTRAINT BO_NN_FILES_ID NOT NULL,
  FIL_C_BUSINESS_KEY      VARCHAR2(500 CHAR) CONSTRAINT BO_NN_FILES_BUSINESS_KEY NOT NULL,
  CONSTRAINT BO_UNIQUE_FILES_BUSINESS_KEY UNIQUE (FIL_C_BUSINESS_KEY),
  FIL_C_NAME              VARCHAR2(200 CHAR),
  FIL_X_CONTENT           BLOB               CONSTRAINT BO_NN_FILES_CONTENT NOT NULL,
  FIL_C_TYPE              VARCHAR2(100 CHAR) CONSTRAINT BO_NN_FILES_TYPE NOT NULL,
  FIL_C_LANGUAGE          VARCHAR2(50 CHAR),
  FIL_OPE_N_ID            NUMBER(12)         CONSTRAINT BO_NN_FILES_OP_ID NOT NULL,
  CONSTRAINT BO_F_OPERATION_FILES FOREIGN KEY (FIL_OPE_N_ID) REFERENCES BO_T_OPERATION (OPE_N_ID),
  FIL_C_MANAGEMENT_ENTITY VARCHAR2(200 CHAR) CONSTRAINT BO_NN_FILES_MGT_ENTITY NOT NULL,
  FIL_D_DATE              TIMESTAMP          CONSTRAINT BO_NN_FILES_DATE NOT NULL,
  FIL_C_LOGIN             VARCHAR2(50 CHAR)  CONSTRAINT BO_NN_FILES_LOGIN NOT NULL,
  FIL_D_SAVE              TIMESTAMP          CONSTRAINT BO_NN_FILES_SAVE NOT NULL,
  CONSTRAINT BO_K_FILES PRIMARY KEY (FIL_N_ID)
);

COMMENT ON TABLE BO_T_FILES IS 'Application Files';
COMMENT ON COLUMN BO_T_FILES.FIL_N_ID IS 'Unique ID';
COMMENT ON COLUMN BO_T_FILES.FIL_C_BUSINESS_KEY IS 'A concatenation of several fields forming a unique business key';
COMMENT ON COLUMN BO_T_FILES.FIL_C_NAME IS 'File''s name';
COMMENT ON COLUMN BO_T_FILES.FIL_X_CONTENT IS 'File''s content';
COMMENT ON COLUMN BO_T_FILES.FIL_C_TYPE IS 'File''s type';
COMMENT ON COLUMN BO_T_FILES.FIL_C_LANGUAGE IS 'File''s language';
COMMENT ON COLUMN BO_T_FILES.FIL_OPE_N_ID IS 'Operation''s unique ID';
COMMENT ON COLUMN BO_T_FILES.FIL_C_MANAGEMENT_ENTITY IS 'Management entity that saved the file';
COMMENT ON COLUMN BO_T_FILES.FIL_D_DATE IS 'Files''s date';
COMMENT ON COLUMN BO_T_FILES.FIL_C_LOGIN IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_FILES.FIL_D_SAVE IS 'Date and time of the last modification in the table content';


CREATE TABLE BO_T_REGISTER_METADATA (
  RMD_N_ID            NUMBER(12)         CONSTRAINT BO_NN_RMD_ID NOT NULL,
  RMD_FIL_N_ID        NUMBER(12)         CONSTRAINT BO_NN_RMD_FIL_ID NOT NULL,
  CONSTRAINT BO_F_RMD_FILES FOREIGN KEY (RMD_FIL_N_ID) REFERENCES BO_T_FILES (FIL_N_ID) ON DELETE CASCADE,
  RMD_C_LOGIN         VARCHAR2(50 CHAR)  CONSTRAINT BO_NN_RMD_LOGIN NOT NULL,
  RMD_D_SAVE          TIMESTAMP          CONSTRAINT BO_NN_RMD_SAVE NOT NULL,
  RMD_N_VALIDATED     NUMBER(1, 0)       CONSTRAINT BO_NN_RMD_VALIDATED NOT NULL,
  RMD_X_REPORT        CLOB               CONSTRAINT BO_NN_RMD_REPORT NOT NULL,
  RMD_X_HASH_TABLE    CLOB               CONSTRAINT BO_NN_RMD_HASH_TABLE NOT NULL,
  RMD_C_MESSAGE_UID   VARCHAR2(200 CHAR) CONSTRAINT BO_NN_RMD_MESSAGE_UID NOT NULL,
  OPE_C_PRE_REG_HASH  VARCHAR2(128 CHAR),
  OPE_C_POST_REG_HASH VARCHAR2(128 CHAR) CONSTRAINT BO_NN_POST_REG_HASH NOT NULL
);


CREATE SEQUENCE BO_S_REGISTER_METADATA
  START WITH 1
  INCREMENT BY 1;

COMMENT ON TABLE BO_T_REGISTER_METADATA IS 'Registry file metadata';
COMMENT ON COLUMN BO_T_REGISTER_METADATA.RMD_N_ID
IS 'unique id';
COMMENT ON COLUMN BO_T_REGISTER_METADATA.RMD_FIL_N_ID IS 'File id';
COMMENT ON COLUMN BO_T_REGISTER_METADATA.RMD_C_LOGIN
IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_REGISTER_METADATA.RMD_D_SAVE
IS 'Date and time of the last modification in the table content';
COMMENT ON COLUMN BO_T_REGISTER_METADATA.RMD_N_VALIDATED IS 'Define if the import has been validated';
COMMENT ON COLUMN BO_T_REGISTER_METADATA.RMD_X_REPORT IS 'Register Report';
COMMENT ON COLUMN BO_T_REGISTER_METADATA.RMD_X_HASH_TABLE IS 'Hash table for users';
COMMENT ON COLUMN BO_T_REGISTER_METADATA.RMD_C_MESSAGE_UID IS 'Message unique identifier composed using xml file';
COMMENT ON COLUMN BO_T_REGISTER_METADATA.OPE_C_PRE_REG_HASH IS 'hash of register files before import';
COMMENT ON COLUMN BO_T_REGISTER_METADATA.OPE_C_POST_REG_HASH IS 'hash of register files after import';


CREATE SEQUENCE BO_S_VOTING_SITE_CONFIG
  START WITH 1
  INCREMENT BY 1;

CREATE TABLE BO_T_VOTING_SITE_CONFIG (
  VSC_N_ID           NUMBER(12)        CONSTRAINT BO_NN_VSC_ID NOT NULL,
  VSC_C_LOGIN        VARCHAR2(50 CHAR) CONSTRAINT BO_NN_VSC_LOGIN NOT NULL,
  VSC_D_SAVE         TIMESTAMP         CONSTRAINT BO_NN_VSC_SAVE NOT NULL,
  VSC_C_DEFAULT_LANG VARCHAR2(2 CHAR)  CONSTRAINT BO_NN_VSC_DEFAULT_LANG NOT NULL,
  VSC_N_OPE_ID       NUMBER(12)        CONSTRAINT BO_NN_VSC_OPE_ID NOT NULL,
  CONSTRAINT BO_F_OPERATION_VSC FOREIGN KEY (VSC_N_OPE_ID) REFERENCES BO_T_OPERATION (OPE_N_ID),
  CONSTRAINT BO_K_VOTING_SITE_CONFIG PRIMARY KEY (VSC_N_ID)
);

CREATE TABLE BO_T_VOTING_SITE_CONFIG_LANG (
  VSCL_C_LANGUAGE  VARCHAR2(2 CHAR) CONSTRAINT BO_NN_VSCL_LANGUAGE NOT NULL,
  VSCL_N_CONFIG_ID NUMBER(12)       CONSTRAINT BO_NN_VSCL_CONFIG_ID NOT NULL,
  CONSTRAINT BO_F_VSC_VSCL FOREIGN KEY (VSCL_N_CONFIG_ID) REFERENCES BO_T_VOTING_SITE_CONFIG (VSC_N_ID)
);

COMMENT ON TABLE BO_T_VOTING_SITE_CONFIG IS 'Registry file metadata';
COMMENT ON COLUMN BO_T_VOTING_SITE_CONFIG.VSC_N_ID IS 'unique id';
COMMENT ON COLUMN BO_T_VOTING_SITE_CONFIG.VSC_C_LOGIN IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_VOTING_SITE_CONFIG.VSC_D_SAVE IS 'Date and time of the last modification in the table content';
COMMENT ON COLUMN BO_T_VOTING_SITE_CONFIG.VSC_C_DEFAULT_LANG IS 'Default lang for operation';
COMMENT ON COLUMN BO_T_VOTING_SITE_CONFIG.VSC_N_OPE_ID IS 'Operation identifier';

COMMENT ON TABLE BO_T_VOTING_SITE_CONFIG_LANG IS 'All languages configured for the voting site';
COMMENT ON COLUMN BO_T_VOTING_SITE_CONFIG_LANG.VSCL_C_LANGUAGE IS 'Language symbol';
COMMENT ON COLUMN BO_T_VOTING_SITE_CONFIG_LANG.VSCL_N_CONFIG_ID IS 'Associated voting site config';

CREATE SEQUENCE BO_S_TESTING_CARDS_LOT START WITH 1 INCREMENT BY 1;

CREATE TABLE BO_T_TESTING_CARDS_LOT (
  TCL_N_ID           NUMBER(12)         CONSTRAINT BO_NN_TCL_ID NOT NULL,
  TCL_C_LOGIN        VARCHAR2(50 CHAR)  CONSTRAINT BO_NN_TCL_LOGIN NOT NULL,
  TCL_D_SAVE         TIMESTAMP          CONSTRAINT BO_NN_TCL_SAVE NOT NULL,
  TCL_C_LOT_NAME     VARCHAR2(20 CHAR)  CONSTRAINT BO_NN_TCL_LOT_NAME NOT NULL,
  TCL_C_CARD_TYPE    VARCHAR2(30 CHAR)  CONSTRAINT BO_NN_TCL_CARD_TYPE NOT NULL,
  TCL_C_SIGNATURE    VARCHAR2(5 CHAR)   CONSTRAINT BO_NN_TCL_SIGNATURE NOT NULL,
  TCL_C_FIRST_NAME   VARCHAR2(30 CHAR)  CONSTRAINT BO_NN_TCL_FIRST_NAME NOT NULL,
  TCL_C_LAST_NAME    VARCHAR2(30 CHAR)  CONSTRAINT BO_NN_TCL_LAST_NAME NOT NULL,
  TCL_D_BIRTHDAY     TIMESTAMP          CONSTRAINT BO_NN_TCL_BIRTHDAY NOT NULL,
  TCL_C_ADDRESS_1    VARCHAR2(200 CHAR),
  TCL_C_ADDRESS_2    VARCHAR2(200 CHAR),
  TCL_C_STREET       VARCHAR2(100 CHAR) CONSTRAINT BO_NN_TCL_STREET NOT NULL,
  TCL_C_POSTAL_CODE  VARCHAR2(6 CHAR)   CONSTRAINT BO_NN_TCL_POSTAL_CODE NOT NULL,
  TCL_C_CITY         VARCHAR2(50 CHAR)  CONSTRAINT BO_NN_TCL_CITY NOT NULL,
  TCL_C_COUNTRY      VARCHAR2(50 CHAR)  CONSTRAINT BO_NN_TCL_COUNTRY NOT NULL,
  TCL_C_LANGUAGE     VARCHAR2(2 CHAR)   CONSTRAINT BO_NN_TCL_LANGUAGE NOT NULL,
  TCL_N_SHOULD_PRINT NUMBER(1, 0)       CONSTRAINT BO_NN_TCL_SHOULD_PRINT NOT NULL,
  TCL_N_COUNT        NUMBER(12)         CONSTRAINT BO_NN_TCL_COUNT NOT NULL,
  TCL_OPE_N_ID       NUMBER(12)         CONSTRAINT BO_NN_TCL_OP_ID NOT NULL,
  CONSTRAINT BO_F_OPERATION_TCL FOREIGN KEY (TCL_OPE_N_ID) REFERENCES BO_T_OPERATION (OPE_N_ID),
  CONSTRAINT BO_K_TESTING_CARDS_LOT PRIMARY KEY (TCL_N_ID)
);

CREATE TABLE BO_T_TESTING_CARDS_LOT_DOI (
  TCLD_C_DOI    VARCHAR2(30 CHAR) CONSTRAINT BO_NN_TCLD_DOI NOT NULL,
  TCLD_N_LOT_ID NUMBER(12)        CONSTRAINT BO_NN_TCLD_LOT_ID NOT NULL,
  CONSTRAINT BO_F_TCL_TCLD FOREIGN KEY (TCLD_N_LOT_ID) REFERENCES BO_T_TESTING_CARDS_LOT (TCL_N_ID)
);


CREATE TABLE BO_T_GUEST_MGNT_ENTITY (
  GME_C_GUEST_MGNT_ENTITY VARCHAR2(200 CHAR) CONSTRAINT BO_NN_GME_MGNT_ENTITY NOT NULL,
  GME_N_OPE_ID            NUMBER(12)         CONSTRAINT BO_NN_GME_OPE_ID NOT NULL,
  CONSTRAINT BO_F_OPE_GME FOREIGN KEY (GME_N_OPE_ID) REFERENCES BO_T_OPERATION (OPE_N_ID)
);

COMMENT ON TABLE BO_T_GUEST_MGNT_ENTITY IS 'operation''s guest management entity';
COMMENT ON COLUMN BO_T_GUEST_MGNT_ENTITY.GME_C_GUEST_MGNT_ENTITY IS 'Management entity name';
COMMENT ON COLUMN BO_T_GUEST_MGNT_ENTITY.GME_N_OPE_ID IS 'Operation id';

CREATE TABLE BO_T_OPE_CONSISTENCY (
  CON_N_ID               NUMBER(12)        CONSTRAINT CON_NN_CON_N_ID NOT NULL,
  CON_N_OPE_ID           NUMBER(12)        CONSTRAINT CON_NN_CON_OPE_ID NOT NULL,
  CONSTRAINT BO_F_CON_OPERATION FOREIGN KEY (CON_N_OPE_ID) REFERENCES BO_T_OPERATION (OPE_N_ID) ON DELETE CASCADE,
  CON_C_LOGIN            VARCHAR2(50 CHAR) CONSTRAINT BO_NN_CON_LOGIN NOT NULL,
  CON_D_SAVE             TIMESTAMP         CONSTRAINT BO_NN_CON_SAVE NOT NULL,
  CON_D_COMPUTATION_DATE TIMESTAMP         CONSTRAINT BO_NN_CON_COMPUTATION_DATE NOT NULL,
  CON_X_REPORT           CLOB              CONSTRAINT BO_NN_CON_REPORT NOT NULL
);

COMMENT ON TABLE BO_T_OPE_CONSISTENCY IS 'operation''s consistency report';
COMMENT ON COLUMN BO_T_OPE_CONSISTENCY.CON_N_OPE_ID IS 'Operation Id';
COMMENT ON COLUMN BO_T_OPE_CONSISTENCY.CON_D_COMPUTATION_DATE IS 'Operation''s last change date taken into account to compute the report';
COMMENT ON COLUMN BO_T_OPE_CONSISTENCY.CON_X_REPORT IS 'Consistency report as a json string';

CREATE SEQUENCE BO_S_OPE_CONSISTENCY
  START WITH 1
  INCREMENT BY 1;

CREATE TABLE BO_T_HIGHLIGHTED_QUESTION (
  HQU_N_ID     NUMBER(12)        CONSTRAINT BO_NN_HQU_ID NOT NULL,
  HQU_C_LOGIN  VARCHAR2(50 CHAR) CONSTRAINT BO_NN_HQU_LOGIN NOT NULL,
  HQU_D_SAVE   TIMESTAMP         CONSTRAINT BO_NN_HQU_SAVE NOT NULL,
  HQU_OPE_N_ID NUMBER(12),
  CONSTRAINT BO_K_HIGHLIGHTED_QUESTION PRIMARY KEY (HQU_N_ID),
  CONSTRAINT BO_F_OPERATION_HLIGH_QUESTION FOREIGN KEY (HQU_OPE_N_ID) REFERENCES BO_T_OPERATION
);
CREATE SEQUENCE BO_S_HIGHLIGHTED_QUESTION START WITH 1 INCREMENT BY 1;

COMMENT ON TABLE BO_T_HIGHLIGHTED_QUESTION IS 'Highlighted question on the voting site';
COMMENT ON COLUMN BO_T_HIGHLIGHTED_QUESTION.HQU_N_ID IS 'Unique Identifier';
COMMENT ON COLUMN BO_T_HIGHLIGHTED_QUESTION.HQU_C_LOGIN IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_HIGHLIGHTED_QUESTION.HQU_D_SAVE IS 'Date and time of the last modification in the table content';
COMMENT ON COLUMN BO_T_HIGHLIGHTED_QUESTION.HQU_OPE_N_ID IS 'Operation Id';

CREATE TABLE BO_T_LOCALIZED_HLIGH_QUESTION (
  LHQ_N_ID                 NUMBER(19, 0)      CONSTRAINT BO_NN_LHQ_ID NOT NULL,
  LHQ_C_LOGIN              VARCHAR2(50 CHAR)  CONSTRAINT BO_NN_LHQ_LOGIN NOT NULL,
  LHQ_D_SAVE               TIMESTAMP          CONSTRAINT BO_NN_LHQ_SAVE NOT NULL,
  LHQ_X_CONTENT            BLOB               CONSTRAINT BO_NN_LHQ_CONTENT NOT NULL,
  LHQ_C_FILENAME           VARCHAR2(255 CHAR) CONSTRAINT BO_NN_LHQ_FILENAME NOT NULL,
  LHQ_C_LANGUAGE           VARCHAR2(50 CHAR)  CONSTRAINT BO_NN_LHQ_LANGUAGE NOT NULL,
  LHQ_C_LOCALIZED_QUESTION VARCHAR2(500 CHAR) CONSTRAINT BO_NN_LHQ_LOCALIZED_QUESTION NOT NULL,
  LHQ_HQU_N_ID             NUMBER(12)         CONSTRAINT BO_NN_LHQ_HQU_ID NOT NULL,
  CONSTRAINT BO_K_LOCALIZED_HLIGH_QUESTION PRIMARY KEY (LHQ_N_ID),
  CONSTRAINT BO_F_QUESTION_LOC_QUESTION FOREIGN KEY (LHQ_HQU_N_ID) REFERENCES BO_T_HIGHLIGHTED_QUESTION,
  CONSTRAINT BO_U_LOCALIZED_HLIGH_QUESTION UNIQUE (LHQ_HQU_N_ID, LHQ_C_LANGUAGE)
);
CREATE SEQUENCE BO_S_LOCALIZED_HLIGH_QUESTION START WITH 1 INCREMENT BY 1;

COMMENT ON TABLE BO_T_LOCALIZED_HLIGH_QUESTION IS 'Localisation of Highlighted question on the voting site';
COMMENT ON COLUMN BO_T_LOCALIZED_HLIGH_QUESTION.LHQ_N_ID IS 'Unique Identifier';
COMMENT ON COLUMN BO_T_LOCALIZED_HLIGH_QUESTION.LHQ_C_LOGIN IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_LOCALIZED_HLIGH_QUESTION.LHQ_D_SAVE IS 'Date and time of the last modification in the table content';
COMMENT ON COLUMN BO_T_LOCALIZED_HLIGH_QUESTION.LHQ_X_CONTENT IS 'Content of the PDF answer file';
COMMENT ON COLUMN BO_T_LOCALIZED_HLIGH_QUESTION.LHQ_C_FILENAME IS 'Name of the PDF answer file';
COMMENT ON COLUMN BO_T_LOCALIZED_HLIGH_QUESTION.LHQ_C_LANGUAGE IS 'Language of the question';
COMMENT ON COLUMN BO_T_LOCALIZED_HLIGH_QUESTION.LHQ_C_LOCALIZED_QUESTION IS 'Operation''s last change date taken into account to compute the report';
COMMENT ON COLUMN BO_T_LOCALIZED_HLIGH_QUESTION.LHQ_HQU_N_ID IS 'Highlighted question ID';


CREATE TABLE BO_T_BALLOT_DOCUMENTATION (
  BDOC_N_ID               NUMBER(19, 0)      CONSTRAINT BO_NN_BDOC_ID NOT NULL,
  BDOC_C_LOGIN            VARCHAR2(255 CHAR) CONSTRAINT BO_NN_BDOC_LOGIN NOT NULL,
  BDOC_D_SAVE             TIMESTAMP          CONSTRAINT BO_NN_BDOC_SAVE NOT NULL,
  BDOC_C_BALLOT_ID        VARCHAR2(255 CHAR) CONSTRAINT BO_NN_BDOC_BALLOT_ID NOT NULL,
  BDOC_X_CONTENT          BLOB               CONSTRAINT BO_NN_BDOC_CONTENT NOT NULL,
  BDOC_C_FILENAME         VARCHAR2(255 CHAR) CONSTRAINT BO_NN_BDOC_FILENAME NOT NULL,
  BDOC_C_LANGUAGE         VARCHAR2(255 CHAR) CONSTRAINT BO_NN_BDOC_LANGUAGE NOT NULL,
  BDOC_C_LOCALIZED_LABEL  VARCHAR2(255 CHAR) CONSTRAINT BO_NN_BDOC_LOCALIZED_LABEL NOT NULL,
  BDOC_C_MANAGMENT_ENTITY VARCHAR2(200 CHAR) CONSTRAINT BO_NN_BDOC_MGT_ENTITY NOT NULL,
  BDOC_OPE_N_ID           NUMBER(19, 0)      CONSTRAINT BO_NN_BDOC_OPE_ID NOT NULL,
  CONSTRAINT BO_K_BALLOT_DOCUMENTATION PRIMARY KEY (BDOC_N_ID),
  CONSTRAINT BO_F_BDOC_OPERATION FOREIGN KEY (BDOC_OPE_N_ID) REFERENCES BO_T_OPERATION
);
CREATE SEQUENCE BO_S_BALLOT_DOCUMENTATION START WITH 1 INCREMENT BY 1;


COMMENT ON TABLE BO_T_BALLOT_DOCUMENTATION IS 'Ballot documentation';
COMMENT ON COLUMN BO_T_BALLOT_DOCUMENTATION.BDOC_N_ID IS 'Unique Identifier';
COMMENT ON COLUMN BO_T_BALLOT_DOCUMENTATION.BDOC_C_LOGIN IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_BALLOT_DOCUMENTATION.BDOC_D_SAVE IS 'Date and time of the last modification in the table content';
COMMENT ON COLUMN BO_T_BALLOT_DOCUMENTATION.BDOC_C_BALLOT_ID IS 'Identifier of the ballot in repository file';
COMMENT ON COLUMN BO_T_BALLOT_DOCUMENTATION.BDOC_X_CONTENT IS 'Content of the documentation in PDF';
COMMENT ON COLUMN BO_T_BALLOT_DOCUMENTATION.BDOC_C_FILENAME IS 'Filename of the documentation';
COMMENT ON COLUMN BO_T_BALLOT_DOCUMENTATION.BDOC_C_LANGUAGE IS 'Language of the documentation';
COMMENT ON COLUMN BO_T_BALLOT_DOCUMENTATION.BDOC_C_LOCALIZED_LABEL IS 'Localized Label describing the documentation';
COMMENT ON COLUMN BO_T_BALLOT_DOCUMENTATION.BDOC_C_MANAGMENT_ENTITY IS 'Management entity who has imported the document';
COMMENT ON COLUMN BO_T_BALLOT_DOCUMENTATION.BDOC_OPE_N_ID IS 'Identifier of the relative operation';


CREATE SEQUENCE BO_S_ELECTION_PAGE_PROP_MODEL START WITH 1 INCREMENT BY 1;
CREATE TABLE BO_T_ELECTION_PAGE_PROP_MODEL (
  EPPM_N_ID                     NUMBER(19, 0)      CONSTRAINT BO_NN_EPPM_ID NOT NULL,
  EPPM_C_LOGIN                  VARCHAR2(255 CHAR),
  EPPM_D_SAVE                   TIMESTAMP,
  EPPM_N_CHANGE_ELECTORAL_LIST  NUMBER(1, 0)       CONSTRAINT BO_NN_EPPM_CHANGE_ELECT_LIST NOT NULL,
  EPPM_N_MULTIPLE_MANDATES      NUMBER(1, 0)       CONSTRAINT BO_NN_EPPM_MULTIPLE_MANDATES NOT NULL,
  EPPM_N_OPEN_CANDIDATURE       NUMBER(1, 0)       CONSTRAINT BO_NN_EPPM_OPEN_CANDIDATURE NOT NULL,
  EPPM_C_CAND_INFO_DISP_MODEL   VARCHAR2(255 CHAR) CONSTRAINT BO_NN_EPPM_CAND_INFO_MODEL NOT NULL,
  EPPM_C_COLUMNS_VERIF_TABLE    VARCHAR2(400 CHAR) CONSTRAINT BO_NN_EPPM_COL_VERIF_TABLE NOT NULL,
  EPPM_C_COL_ORDER_VERIF_TABLE  VARCHAR2(400 CHAR),
  EPPM_N_DISPLAY_POS_ON_COMPACT NUMBER(1, 0)       CONSTRAINT BO_NN_EPPM_DIS_POS_ON_COMPACT NOT NULL,
  EPPM_N_DISPLAY_POS_ON_MOD     NUMBER(1, 0)       CONSTRAINT BO_NN_EPPM_DIS_POS_ON_MOD NOT NULL,
  EPPM_N_CANDIDATE_SEARCH_FORM  NUMBER(1, 0)       CONSTRAINT BO_NN_EPPM_CAND_SEARCH_FORM NOT NULL,
  EPPM_N_DISPLAY_EMPTY_POS      NUMBER(1, 0)       CONSTRAINT BO_NN_EPPM_DIS_EMPTY_POS NOT NULL,
  EPPM_N_DISP_LIST_VERIF_CODE   NUMBER(1, 0)       CONSTRAINT BO_NN_EPPM_DIS_LIST_VCODE NOT NULL,
  EPPM_N_DISPLAY_SUFFRAGE_COUNT NUMBER(1, 0)       CONSTRAINT BO_NN_EPPM_DIS_SUF_COUNT NOT NULL,
  EPPM_N_DISP_VOID_ON_EMPTY_BP  NUMBER(1, 0)       CONSTRAINT BO_NN_EPPM_DIS_VOID_EMPTY_BP NOT NULL,
  EPPM_C_MODEL_NAME             VARCHAR2(255 CHAR) CONSTRAINT BO_NN_EPPM_MODEL_NAME NOT NULL,
  EPPM_OPE_N_ID                 NUMBER(19, 0)      CONSTRAINT BO_NN_EPPM_OPE_ID NOT NULL,
  CONSTRAINT BO_K_ELECTION_PAGE_PROP_MODEL PRIMARY KEY (EPPM_N_ID),
  CONSTRAINT BO_F_EPPM_OPE FOREIGN KEY (EPPM_OPE_N_ID) REFERENCES BO_T_OPERATION
);


COMMENT ON TABLE BO_T_ELECTION_PAGE_PROP_MODEL IS 'Model for a voting site election page property available for an operation';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_ID IS 'Unique Identifier';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_C_LOGIN IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_D_SAVE IS 'Date and time of the last modification in the table content';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_OPE_N_ID IS 'Identifier of the operation for which this model applies';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_C_MODEL_NAME IS 'The name of the model';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_CANDIDATE_SEARCH_FORM IS 'should display candidate search form on the voting site';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_CHANGE_ELECTORAL_LIST IS 'should allow change of electoral list on the voting site';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_DISPLAY_EMPTY_POS IS 'should display empty position on the voting site';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_DISPLAY_POS_ON_COMPACT IS 'should display candidate position on a compact ballot paper';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_DISPLAY_POS_ON_MOD IS 'should display candidate position on a modified ballot paper';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_DISPLAY_SUFFRAGE_COUNT IS 'should display suffrage count';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_DISP_LIST_VERIF_CODE IS 'should display verification code on election lists';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_C_CAND_INFO_DISP_MODEL IS 'candidate extra information display model';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_C_COLUMNS_VERIF_TABLE IS 'Ordered columns to display on verification table (pipe separated)';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_C_COL_ORDER_VERIF_TABLE IS 'Ordered sort order of columns on verification table (pipe separated)';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_OPEN_CANDIDATURE IS 'should allow open candidature';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_MULTIPLE_MANDATES IS 'should allow multiple mandates';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP_MODEL.EPPM_N_DISP_VOID_ON_EMPTY_BP IS 'should display void ballot paper when there is no candidate or no name of the party';


CREATE SEQUENCE BO_S_ELECTION_PAGE_PROP START WITH 1 INCREMENT BY 1;
CREATE TABLE BO_T_ELECTION_PAGE_PROP (
  EPP_N_ID      NUMBER(19, 0)      CONSTRAINT BO_NN_EPP_ID NOT NULL,
  EPP_C_LOGIN   VARCHAR2(255 CHAR),
  EPP_D_SAVE    TIMESTAMP,
  EPP_C_BALLOT  VARCHAR2(255 CHAR) CONSTRAINT BO_NN_EPP_BALLOT NOT NULL,
  EPP_EPPM_N_ID NUMBER(19, 0)      CONSTRAINT BO_NN_EPP_EPPM_ID NOT NULL,
  CONSTRAINT BO_K_ELECTION_PAGE_PROP PRIMARY KEY (EPP_N_ID),
  CONSTRAINT BO_F_EPP_EPPM FOREIGN KEY (EPP_EPPM_N_ID) REFERENCES BO_T_ELECTION_PAGE_PROP_MODEL
);


COMMENT ON TABLE BO_T_ELECTION_PAGE_PROP IS 'link table between a ballot and election page property model';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP.EPP_N_ID IS 'Unique Identifier';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP.EPP_C_LOGIN IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP.EPP_D_SAVE IS 'Date and time of the last modification in the table content';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP.EPP_C_BALLOT IS 'Identifier of the ballot in repository file';
COMMENT ON COLUMN BO_T_ELECTION_PAGE_PROP.EPP_EPPM_N_ID IS 'Identifier of election page property model';


CREATE SEQUENCE BO_S_DICTIONARY START WITH 1 INCREMENT BY 1;
CREATE TABLE BO_T_DICTIONARY (
  DIC_N_ID          NUMBER(19, 0)      CONSTRAINT BO_NN_DIC_ID NOT NULL,
  DIC_S_DATA_TYPE   VARCHAR2(255 CHAR) CONSTRAINT BO_NN_DIC_DATA_TYPE NOT NULL,
  DIC_S_SCOPE_VALUE VARCHAR2(255 CHAR),
  DIC_X_CONTENT     CLOB               CONSTRAINT BO_NN_DIC_CONTENT NOT NULL,
  CONSTRAINT BO_K_DICTIONARY PRIMARY KEY (DIC_N_ID)
);

COMMENT ON TABLE BO_T_DICTIONARY IS 'Table containing static data';
COMMENT ON COLUMN BO_T_DICTIONARY.DIC_N_ID IS 'Unique Identifier';
COMMENT ON COLUMN BO_T_DICTIONARY.DIC_X_CONTENT IS 'Content may be Json type for complex objects';
COMMENT ON COLUMN BO_T_DICTIONARY.DIC_S_DATA_TYPE IS 'Type of data stored';
COMMENT ON COLUMN BO_T_DICTIONARY.DIC_S_SCOPE_VALUE IS 'Scope of the data : null for common data, canton abbreviation for cantonal data or management entity name';

CREATE TABLE BO_T_DOWNLOAD_TOKEN (
  DT_C_ID            VARCHAR2(255 CHAR) CONSTRAINT BO_NN_DT_ID NOT NULL,
  DT_D_CREATION_DATE TIMESTAMP          CONSTRAINT BO_NN_DT_CREATION_DATE NOT NULL,
  DT_C_LOGIN         VARCHAR2(255 CHAR) CONSTRAINT BO_NN_DT_LOGIN NOT NULL,
  DT_C_PATH          VARCHAR2(255 CHAR) CONSTRAINT BO_NN_PATH NOT NULL,
  DT_OPE_N_ID        NUMBER(19, 0)      CONSTRAINT BO_NN_DT_OPE_ID NOT NULL,
  CONSTRAINT BO_K_DOWNLOAD_TOKEN PRIMARY KEY (DT_C_ID),
  CONSTRAINT BO_F_DT_OPE FOREIGN KEY (DT_OPE_N_ID) REFERENCES BO_T_OPERATION
);

COMMENT ON TABLE BO_T_DOWNLOAD_TOKEN IS 'Table containing download token to manage download recovery';
COMMENT ON COLUMN BO_T_DOWNLOAD_TOKEN.DT_C_ID IS 'Unique Identifier';
COMMENT ON COLUMN BO_T_DOWNLOAD_TOKEN.DT_D_CREATION_DATE IS 'Token creation date';
COMMENT ON COLUMN BO_T_DOWNLOAD_TOKEN.DT_C_LOGIN IS 'Token creation user';
COMMENT ON COLUMN BO_T_DOWNLOAD_TOKEN.DT_C_PATH IS 'File path';
COMMENT ON COLUMN BO_T_DOWNLOAD_TOKEN.DT_OPE_N_ID IS 'Operation';

CREATE SEQUENCE BO_S_ELECTORAL_AUTHORITY_KEYS START WITH 1 INCREMENT BY 1;

CREATE TABLE BO_T_ELECTORAL_AUTHORITY_KEY (
  EAK_N_ID                NUMBER(12)         CONSTRAINT BO_NN_EAK_ID NOT NULL,
  EAK_C_NAME              VARCHAR2(200 CHAR) CONSTRAINT BO_NN_EAK_NAME NOT NULL,
  EAK_X_CONTENT           BLOB               CONSTRAINT BO_NN_EAK_CONTENT NOT NULL,
  EAK_C_MANAGEMENT_ENTITY VARCHAR2(200 CHAR) CONSTRAINT BO_NN_EAK_MGT_ENTITY NOT NULL,
  EAK_C_LOGIN             VARCHAR2(50 CHAR)  CONSTRAINT BO_NN_EAK_LOGIN NOT NULL,
  EAK_D_SAVE              TIMESTAMP          CONSTRAINT BO_NN_EAK_SAVE NOT NULL,
  EAK_D_IMPORT_DATE       TIMESTAMP          CONSTRAINT BO_NN_EAK_IMPORT_DATE NOT NULL,
  CONSTRAINT BO_K_ELECTORAL_AUTHORITY_KEYS PRIMARY KEY (EAK_N_ID),
  CONSTRAINT BO_U_EAK_NAME_MGT_ENTITY UNIQUE (EAK_C_MANAGEMENT_ENTITY, EAK_C_NAME)
);

COMMENT ON TABLE BO_T_ELECTORAL_AUTHORITY_KEY IS 'Electoral Authority Keys';
COMMENT ON COLUMN BO_T_ELECTORAL_AUTHORITY_KEY.EAK_N_ID IS 'Unique ID';
COMMENT ON COLUMN BO_T_ELECTORAL_AUTHORITY_KEY.EAK_C_NAME IS 'Keys''s name';
COMMENT ON COLUMN BO_T_ELECTORAL_AUTHORITY_KEY.EAK_X_CONTENT IS 'Key''s content';
COMMENT ON COLUMN BO_T_ELECTORAL_AUTHORITY_KEY.EAK_C_MANAGEMENT_ENTITY IS 'Management entity that saved the key';
COMMENT ON COLUMN BO_T_ELECTORAL_AUTHORITY_KEY.EAK_C_LOGIN IS 'User name who last modified the table content';
COMMENT ON COLUMN BO_T_ELECTORAL_AUTHORITY_KEY.EAK_D_SAVE IS 'Date and time of the last modification in the table content';
COMMENT ON COLUMN BO_T_ELECTORAL_AUTHORITY_KEY.EAK_D_IMPORT_DATE IS 'Date and time of the initial import';


CREATE TABLE BO_T_ELECT_AUTH_KEY_CONFIG (
  EAKC_N_ID               NUMBER(19, 0)      NOT NULL,
  EAKC_C_LOGIN            VARCHAR2(255 CHAR) CONSTRAINT BO_NN_EAKC_LOGIN NOT NULL,
  EAKC_D_SAVE             TIMESTAMP          CONSTRAINT BO_NN_EAKC_SAVE NOT NULL,
  EAKC_N_OPE_ID           NUMBER(19, 0)      NOT NULL,
  EAKC_N_ELEC_AUTH_KEY_ID NUMBER(19, 0)      NOT NULL,
  CONSTRAINT BO_K_ELECT_AUTH_KEY_CONFIG PRIMARY KEY (EAKC_N_ID),
  CONSTRAINT BO_F_EAKC_OPE FOREIGN KEY (EAKC_N_OPE_ID) REFERENCES BO_T_OPERATION,
  CONSTRAINT BO_F_EAKC_ELEC_AUTH_KEY FOREIGN KEY (EAKC_N_ELEC_AUTH_KEY_ID) REFERENCES BO_T_ELECTORAL_AUTHORITY_KEY
);
CREATE SEQUENCE BO_S_ELECT_AUTH_KEY_CONFIG
  START WITH 1
  INCREMENT BY 1;


COMMENT ON TABLE BO_T_ELECT_AUTH_KEY_CONFIG IS 'Operation''s electoral authority key configuration';
COMMENT ON COLUMN BO_T_ELECT_AUTH_KEY_CONFIG.EAKC_N_OPE_ID IS 'Operation ID';
COMMENT ON COLUMN BO_T_ELECT_AUTH_KEY_CONFIG.EAKC_N_ELEC_AUTH_KEY_ID IS 'Electoral authority key ID';


CREATE TABLE BO_T_SIMUL_PERIOD_CONFIG (
  SPC_N_ID           NUMBER(19, 0)      CONSTRAINT BO_NN_SPC_ID NOT NULL,
  SPC_N_OPE_ID       NUMBER(19, 0)      CONSTRAINT BO_NN_SPC_OPE_ID NOT NULL,
  SPC_C_LOGIN        VARCHAR2(255 CHAR) CONSTRAINT BO_NN_SPC_LOGIN NOT NULL,
  SPC_D_SAVE         TIMESTAMP          CONSTRAINT BO_NN_SPC_SAVE NOT NULL,
  SPC_D_DATE_CLOSE   TIMESTAMP          CONSTRAINT BO_NN_SPC_DATE_CLOSE NOT NULL,
  SPC_D_DATE_OPEN    TIMESTAMP          CONSTRAINT BO_NN_SPC_DATE_OPEN NOT NULL,
  SPC_N_GRACE_PERIOD NUMBER(10, 0)      CONSTRAINT BO_NN_SPC_GRACE_PERIOD NOT NULL,
  CONSTRAINT BO_K_SIMUL_PERIOD_CONFIG PRIMARY KEY (SPC_N_OPE_ID),
  CONSTRAINT BO_F_SPC_OPE FOREIGN KEY (SPC_N_OPE_ID) REFERENCES BO_T_OPERATION
);

COMMENT ON TABLE BO_T_SIMUL_PERIOD_CONFIG IS 'Operation''s simulation dates configuration';
COMMENT ON COLUMN BO_T_SIMUL_PERIOD_CONFIG.SPC_N_OPE_ID
IS 'Unique ID';
COMMENT ON COLUMN BO_T_SIMUL_PERIOD_CONFIG.SPC_N_OPE_ID IS 'Operation ID';
COMMENT ON COLUMN BO_T_SIMUL_PERIOD_CONFIG.SPC_D_DATE_CLOSE IS 'Closing date of the simulation site';
COMMENT ON COLUMN BO_T_SIMUL_PERIOD_CONFIG.SPC_D_DATE_OPEN IS 'Opening date of the simulation site';
COMMENT ON COLUMN BO_T_SIMUL_PERIOD_CONFIG.SPC_N_GRACE_PERIOD IS 'Grace period of the simulation site';
CREATE SEQUENCE BO_S_SIMUL_PERIOD_CONFIG
  START WITH 1
  INCREMENT BY 1;